import {WhereBuilder} from './type/WhereBuilder.ts'

/**
 * Abstract base class for query builder scopes.
 * @abstract
 */
export abstract class Scope {
    /**
     * Applies this scope to the incoming query.
     * @param {WhereBuilder} query
     * @return WhereBuilder
     * @abstract
     */
    abstract apply(query: WhereBuilder): WhereBuilder
}
